//+------------------------------------------------------------------+
//|                                          Multi BB Over Alert.mq4 |
//|                                                 Cutzpr@Forex-TSD |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window
extern string Details="Enter TF in Minutes";
extern string Details1="Enter Period for each TF, 20 is default";
//
extern int BB_TF1=5;
extern int PERIOD1=20;
extern color TF1Color=Red;
extern bool TF1_Alert;
//
extern int BB_TF2=15;
extern int PERIOD2=20;
extern color TF2Color=Orange;
extern bool TF2_Alert;
//
extern int BB_TF3=60;
extern int PERIOD3=20;
extern color TF3Color=Brown;
extern bool TF3_Alert;
//
extern bool MultiTF_Alert=true;
extern bool ShowMA=false; // Enable if you would like to see the middle MA

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
  {
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   int objtotal=ObjectsTotal();
   
   for(;objtotal>0;objtotal--) ObjectDelete(DoubleToStr(objtotal,0));
      
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted(), limit;
 
   if(counted_bars>0)
      counted_bars--;
   
   limit=Bars-counted_bars;
  
   for(int i=0;i<limit;i++)
   {
                     
     
      double
      BB1H=iBands(NULL,BB_TF1,PERIOD1,2,0,PRICE_HIGH,MODE_UPPER,0),  // BB for the 3 time frames
      BB1L=iBands(NULL,BB_TF1,PERIOD1,2,0,PRICE_LOW,MODE_LOWER,0),
      BB2H=iBands(NULL,BB_TF2,PERIOD2,2,0,PRICE_HIGH,MODE_UPPER,0),
      BB2L=iBands(NULL,BB_TF2,PERIOD2,2,0,PRICE_LOW,MODE_LOWER,0),
      BB3H=iBands(NULL,BB_TF3,PERIOD3,2,0,PRICE_HIGH,MODE_UPPER,0),
      BB3L=iBands(NULL,BB_TF3,PERIOD3,2,0,PRICE_LOW,MODE_LOWER,0),
      //Middle moving Averages
      BB1M=iBands(NULL,BB_TF1,PERIOD1,2,0,PRICE_MEDIAN,MODE_MAIN,0),
      BB2M=iBands(NULL,BB_TF2,PERIOD1,2,0,PRICE_MEDIAN,MODE_MAIN,0),
      BB3M=iBands(NULL,BB_TF3,PERIOD1,2,0,PRICE_MEDIAN,MODE_MAIN,0);
      
   
   
   //----------------------------------------------------------------
   //Delete all previously made Objects
   int objtotal=ObjectsTotal();
   
   for(;objtotal>0;objtotal--) ObjectDelete(DoubleToStr(objtotal,0)+"!");
   
   int adjust;
   switch(Period())
     {
       case 1:     adjust=1*15*60; break;  // Adjust the last coordinate for the TF
       case 5:     adjust=5*15*60; break;  
       case 15:    adjust=15*15*60; break;
       case 30:    adjust=30*15*60; break;
       case 60:    adjust=60*15*60; break;
       case 240:   adjust=240*15*60; break;
       case 1440:  adjust=1440*15*60; break;
       case 10080: adjust=10080*15*60; break;
       case 43200: adjust=43200*15*60; break;
     }

   
   
   // Create all object lines 
   ObjectCreate("1",OBJ_TREND,0,TimeCurrent(),BB1H,TimeCurrent()+adjust,BB1H);
   ObjectCreate("2",OBJ_TREND,0,TimeCurrent(),BB1L,TimeCurrent()+adjust,BB1L);
   ObjectCreate("3",OBJ_TREND,0,TimeCurrent(),BB2H,TimeCurrent()+adjust,BB2H);
   ObjectCreate("4",OBJ_TREND,0,TimeCurrent(),BB2L,TimeCurrent()+adjust,BB2L);
   ObjectCreate("5",OBJ_TREND,0,TimeCurrent(),BB3H,TimeCurrent()+adjust,BB3H);
   ObjectCreate("6",OBJ_TREND,0,TimeCurrent(),BB3L,TimeCurrent()+adjust,BB3L);
   
   //Style all object lines
   ObjectSet("1",OBJPROP_COLOR,TF1Color);
   ObjectSet("2",OBJPROP_COLOR,TF1Color);
   ObjectSet("3",OBJPROP_COLOR,TF2Color);
   ObjectSet("4",OBJPROP_COLOR,TF2Color);
   ObjectSet("5",OBJPROP_COLOR,TF3Color);
   ObjectSet("6",OBJPROP_COLOR,TF3Color);
   
   ObjectSet("1",OBJPROP_WIDTH,2);
   ObjectSet("2",OBJPROP_WIDTH,2);
   ObjectSet("3",OBJPROP_WIDTH,2);
   ObjectSet("4",OBJPROP_WIDTH,2);
   ObjectSet("5",OBJPROP_WIDTH,3);
   ObjectSet("6",OBJPROP_WIDTH,3);
 
  // Different set of Objects for Trend Line Labels
  ObjectCreate("7",OBJ_TEXT,0,ObjectGet("1",OBJPROP_TIME1)+adjust,ObjectGet("1",OBJPROP_PRICE2));
  ObjectCreate("8",OBJ_TEXT,0,ObjectGet("2",OBJPROP_TIME1)+adjust,ObjectGet("2",OBJPROP_PRICE2));
  ObjectCreate("9",OBJ_TEXT,0,ObjectGet("3",OBJPROP_TIME1)+adjust,ObjectGet("3",OBJPROP_PRICE2));
  ObjectCreate("10",OBJ_TEXT,0,ObjectGet("4",OBJPROP_TIME1)+adjust,ObjectGet("4",OBJPROP_PRICE2));
  ObjectCreate("11",OBJ_TEXT,0,ObjectGet("5",OBJPROP_TIME1)+adjust,ObjectGet("5",OBJPROP_PRICE2));
  ObjectCreate("12",OBJ_TEXT,0,ObjectGet("6",OBJPROP_TIME1)+adjust,ObjectGet("6",OBJPROP_PRICE2));
  
  ObjectSetText("7","Upper TF1 BB",8,"Arial",TF1Color);   
  ObjectSetText("8","Lower TF1 BB",8,"Arial",TF1Color);      
 
  ObjectSetText("9","Upper TF2  BB",8,"Arial",TF2Color); 
  ObjectSetText("10","Lower TF2 BB",8,"Arial",TF2Color);   
 
  ObjectSetText("11","Upper TF3 BB",8,"Arial",TF3Color);
  ObjectSetText("12","Lower TF3 BB",8,"Arial",TF3Color);
  
  //Show Middle Moving Average
  
  if(ShowMA)
     {
     ObjectCreate("13!",OBJ_TREND,0,TimeCurrent(),BB1M,TimeCurrent()+adjust,BB1M);
     ObjectCreate("14",OBJ_TREND,0,TimeCurrent(),BB1M,TimeCurrent()+adjust,BB1M);
     ObjectCreate("15",OBJ_TREND,0,TimeCurrent(),BB2M,TimeCurrent()+adjust,BB2M);
     
     ObjectSet("13",OBJPROP_STYLE,STYLE_DASH);
     ObjectSet("14",OBJPROP_STYLE,STYLE_DASH);
     ObjectSet("15",OBJPROP_STYLE,STYLE_DASH);
     
     ObjectSet("13",OBJPROP_COLOR,TF1Color);
     ObjectSet("14",OBJPROP_COLOR,TF2Color);
     ObjectSet("15",OBJPROP_COLOR,TF3Color);
     
     ObjectCreate("16",OBJ_TEXT,0,ObjectGet("13",OBJPROP_TIME1)+adjust,ObjectGet("13",OBJPROP_PRICE2));
     ObjectCreate("17",OBJ_TEXT,0,ObjectGet("14",OBJPROP_TIME1)+adjust,ObjectGet("14",OBJPROP_PRICE2));
     ObjectCreate("18",OBJ_TEXT,0,ObjectGet("15",OBJPROP_TIME1)+adjust,ObjectGet("15",OBJPROP_PRICE2));

     ObjectSetText("16","TF1 BB",8,"Arial",TF1Color );   
     ObjectSetText("17","TF2 BB",8,"Arial",TF2Color );  
     ObjectSetText("18","TF3 BB",8,"Arial",TF3Color ); 
     }
     
  // Alerts
  
   if(TF1_Alert)
      {
       if(Ask>BB1H) Alert(Symbol()+" Price is Above TF1 Bollinger Band: Overbought");
       if(Bid<BB1L) Alert(Symbol()+" Price is Below TF1 Bollinger Band: Oversold");
      }
    
   if(TF2_Alert)
      {
       if(Ask>BB2H) Alert(Symbol()+" Price is Above TF2 Bollinger Band: Overbought");
       if(Bid<BB2L) Alert(Symbol()+" Price is Below TF2 Bollinger Band: Oversold");
      } 
      
   if(TF3_Alert)
      {
       if(Ask>BB3H) Alert(Symbol()+" Price is Above TF3 Bollinger Band: Overbought");
       if(Bid<BB3L) Alert(Symbol()+" Price is Below TF3 Bollinger Band: Oversold");
      }
      
        
   if(MultiTF_Alert)
      {
      if(Ask>BB1H && Ask>BB2H && Ask>BB3H) Alert(Symbol()+": Price is above all Bollinger Bands: Extremely OverBought");
      if(Bid<BB1L && Bid<BB2L && Bid<BB3L) Alert(Symbol()+": Price is below all Bollinger Bands: Extremely Oversold");
      }
   
  }
   
   
   return(0);
  }

